import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Thurallor.Common.Utils.Utils_11";

color = Turbine.UI.Color.Red;
opacity = 0.5;

function CreateOverlay()
    overlay = Turbine.UI.Window();
    overlay:SetBackground("Thurallor/HaveAggro/starburst.tga");
    overlay:SetBackColor(color);
    overlay:SetBackColorBlendMode(Turbine.UI.BlendMode.Color);
    overlay:SetOpacity(opacity);
    overlay:SetVisible(true);
    overlay:SetMouseVisible(false);
    overlay:SetZOrder(-2147483647);
    overlay:SetStretchMode(2);
    nativeWidth, nativeHeight = overlay:GetSize();
    local screenWidth, screenHeight = Turbine.UI.Display:GetSize();
    expansion = math.max(screenWidth / nativeWidth, screenHeight / nativeHeight);
    width, height = nativeWidth * expansion, nativeHeight * expansion;
    overlay:SetStretchMode(1);
    overlay:SetSize(width, height);
    overlay:SetLeft((screenWidth - width) / 2);
    overlay:SetTop ((screenHeight - height) / 2);
    overlay:SetVisible(false);
end

function DisplaySizeChanged()
    overlay:Close();
    CreateOverlay();
end

function TargetsTargetChanged()
    local targetsTarget = target:GetTarget();
    if (targetsTarget and targetsTarget.IsLocalPlayer and targetsTarget.IsLocalPlayer()) then
        -- Have aggro
        if (player:IsInCombat()) then
            overlay:SetVisible(true);
        end
    else
        overlay:SetVisible(false);
    end
end

function TargetChanged()
    if (target) then
        RemoveCallback(target, "TargetChanged", TargetsTargetChanged);
    end
    target = player:GetTarget();
    if (target and target.GetTarget) then
        TargetsTargetChanged();
        AddCallback(target, "TargetChanged", TargetsTargetChanged);
    else
        overlay:SetVisible(false);
    end
end

CreateOverlay();
player = Turbine.Gameplay.LocalPlayer.GetInstance();
target = player:GetTarget();
AddCallback(player, "TargetChanged", TargetChanged);
AddCallback(Turbine.UI.Display, "SizeChanged", DisplaySizeChanged);
